#include <Servo.h> 

#define RojoDer 2
#define VerdDer 3
#define AzulDer 4

#define RojoIzq 16
#define VerdIzq 14
#define AzulIzq 15

#define RojoCab A3
#define VerdCab A2
#define AzulCab A1
 
Servo Servo1, Servo2, MicroMot1, MicroMot2;  //Creacion de los Objetos para el control de los servomotores
 
int contador=0, contador1=0; //variable pos util para el funcionamiento de los motores, variable contador util para los leds.
char Dato_Serial=0, Enable_Leds=0;   //variable donde se leer el valor del puerto Serial, proveniente del Raspberry.
 
void setup() 
{
  /*----------------------Configuracion del TIMER3----------------------------*/
  cli();//stop interrupts
  TCCR3A = 0;// set entire TCCR1A register to 0
  TCCR3B = 0;// same for TCCR1B
  TCNT3  = 0;//initialize counter value to 0
  // set compare match register for 1hz increments
  OCR3A = 15999;// = (16*10^6) / (1*1024) - 1 (must be <65536)
  // turn on CTC mode
  TCCR3B |= (1 << WGM32);
  // Set CS10 and CS12 bits for 1 prescaler
  TCCR3B |= (1 << CS30);  
  // enable timer compare interrupt
  TIMSK3 |= (1 << OCIE3A);
  sei();//allow interrupts
  /*--------------------------------------------------------------------------*/
  /*--------------------Configuracion del puerto Serial-----------------------*/
  Serial1.begin(9600); //Habilitacion de la comunicacion serial de los pines 0 y 1 de Arduino Pro Micro.
  Serial.begin(9600);
  /*-----------------Configuracion de los pines Servomotes--------------------*/
  Servo1.attach(5);       //Pin para el servomotor de la mano derecha
  Servo2.attach(6);       //Pin para el servomotor de la mano izquierda
  MicroMot1.attach(9);    //Pin para el motor de la mano derecha
  MicroMot2.attach(10);   //Pin para el motor de la mano izquierda
  delay(10);
  SetearMotores(20,155,90,90);
  /*--------------------------------------------------------------------------*/
  /*----------------Configuracion de los pines para los led-------------------*/
  pinMode(RojoDer, OUTPUT); //Pin de los led de la mano derecha ROJO  
  pinMode(VerdDer, OUTPUT); //Pin de los led de la mano derecha VERDE  
  pinMode(AzulDer, OUTPUT); //Pin de los led de la mano derecha AZUL

  pinMode(AzulIzq, OUTPUT); //Pin de los led de la mano izquierda  AZUL
  pinMode(VerdIzq, OUTPUT); //Pin de los led de la mano izquierda  VERDE
  pinMode(RojoIzq, OUTPUT); //Pin de los led de la mano izquierda  ROJO

  pinMode(RojoCab, OUTPUT); //Pin de los led de la mano izquierda  ROJO
  pinMode(VerdCab, OUTPUT); //Pin de los led de la mano izquierda  VERDE  
  pinMode(AzulCab, OUTPUT); //Pin de los led de la mano izquierda  AZUL
  /*--------------------------------------------------------------------------*/
  InicializacionLeds();
  delay(100);
  SepararServos();
} 

ISR(TIMER3_COMPA_vect){//timer0 interrupt 2kHz toggles pin 8
//generates pulse wave of frequency 2kHz/2 = 1kHz (takes two cycles for full wave- toggle high then toggle low)
  contador+=1;  
   if(Enable_Leds==1){
          if(contador>=1000){
                digitalWrite(AzulIzq, digitalRead(AzulIzq)^1);
                contador=0;
          }
    }
    if(Enable_Leds==4){
          if(contador>=1000){
                digitalWrite(VerdDer, digitalRead(VerdDer)^1);
                contador1+=1;
                contador=0;
          }
          if(contador1>=4){
                digitalWrite(AzulIzq, digitalRead(AzulIzq)^1);
                contador1=0;
            }
    }
    if(Enable_Leds==2){
          if(contador>=150){
                digitalWrite(RojoIzq, digitalRead(RojoIzq)^1);
                digitalWrite(RojoDer, digitalRead(RojoDer)^1);
                contador=0;
          }
    }
    if(Enable_Leds==3){
          if(contador==100){
                InicializacionLeds();
                digitalWrite(VerdIzq, digitalRead(VerdIzq)^1);
                digitalWrite(VerdDer, digitalRead(VerdDer)^1);
          }
          if(contador==200){
                InicializacionLeds();
                digitalWrite(VerdIzq, digitalRead(VerdIzq)^1);
                digitalWrite(AzulIzq, digitalRead(AzulIzq)^1);
                digitalWrite(VerdDer, digitalRead(VerdDer)^1);
                digitalWrite(AzulDer, digitalRead(AzulDer)^1);
          }
          if(contador==300){
                InicializacionLeds();
                digitalWrite(AzulIzq, digitalRead(AzulIzq)^1);
                digitalWrite(AzulDer, digitalRead(AzulDer)^1);
          }
          if(contador==400){
                InicializacionLeds();
                digitalWrite(RojoIzq, digitalRead(RojoIzq)^1);
                digitalWrite(AzulIzq, digitalRead(AzulIzq)^1);
                digitalWrite(RojoDer, digitalRead(RojoDer)^1);
                digitalWrite(AzulDer, digitalRead(AzulDer)^1);
          }
          if(contador==500){
                InicializacionLeds();
                digitalWrite(RojoIzq, digitalRead(RojoIzq)^1);
                digitalWrite(RojoDer, digitalRead(RojoDer)^1);
          }
          if(contador==600){
                InicializacionLeds();
                digitalWrite(RojoIzq, digitalRead(RojoIzq)^1);
                digitalWrite(VerdIzq, digitalRead(VerdIzq)^1);
                digitalWrite(RojoDer, digitalRead(RojoDer)^1);
                digitalWrite(VerdDer, digitalRead(VerdDer)^1);
                contador=0;
          }            
      }
}

void SetearMotores(int VServo1, int VServo2, int VMotor1, int VMotor2) {
      delay(10);
      int pos;
      int posAct1=Servo1.read(),posAct2=Servo2.read();
      MicroMot1.write(VMotor1);
      MicroMot2.write(VMotor2);
      if(VServo1<posAct1){
            for(pos=posAct1;pos>=VServo1;pos-=1){
                    Servo1.write(pos);
                    delay(8);
                    }
         }
      else{
            for(pos=posAct1;pos<=VServo1;pos+=1){
                    Servo1.write(pos);
                    delay(8);
                    } 
      }        
      if(VServo2<posAct2){
            for(pos=posAct2;pos>=VServo2;pos-=1){
                    Servo2.write(pos);
                    delay(8);
                    }
         }
      else{
            for(pos=posAct2;pos<=VServo2;pos+=1){
                    Servo2.write(pos);
                    delay(8);
                    } 
      }
      delay(10);
}

void UnirServos()
{
  Servo1.attach(5);  //Pin para el servomotor de la mano derecha
  Servo2.attach(6);  //Pin para el servomotor de la mano izquierda
  MicroMot1.attach(9);  //Pin para el motor de la derecha
  MicroMot2.attach(10);  //Pin para el motor de la izquierda  
  delay(10);
}

void SepararServos()
{
  Servo1.detach();
  Servo2.detach();
  MicroMot1.detach();
  MicroMot2.detach(); 
  delay(10);
}

void InicializacionLeds()
{
  digitalWrite(RojoDer, HIGH);
  digitalWrite(VerdDer, HIGH);
  digitalWrite(AzulDer, HIGH);
  digitalWrite(RojoIzq, HIGH);
  digitalWrite(VerdIzq, HIGH);
  digitalWrite(AzulIzq, HIGH);
  digitalWrite(RojoCab, HIGH);
  digitalWrite(VerdCab, HIGH);
  digitalWrite(AzulCab, HIGH);
}
 
void loop() 
{                     
    if(Serial1.available())
        Dato_Serial=Serial1.read(); 
/********************************Accion a realizar para levantar el Brazo***********************************/        
    if(Dato_Serial=='L'){   //Dato recibido desde el Raspberry para levantar la mano derecha
                Serial.write(Dato_Serial);
                contador=0;
                Enable_Leds=1; //Habilitación de la bandera para e encendido del led azul de la mano derecha
                UnirServos();
                InicializacionLeds();               
                SetearMotores(20,110,90,90);
                Dato_Serial=0;
                delay(1);
                SepararServos();
            }   
/*********************************************************************************************************/
/********************************Accion a realizar para levantar el Brazo***********************************/        
    if(Dato_Serial=='V'){   //Dato recibido desde el Raspberry para levantar la mano derecha e izquierda
                Serial.write(Dato_Serial);
                contador=0;
                Enable_Leds=4; //Habilitación de la bandera para e encendido del led azul de la mano derecha
                UnirServos();
                InicializacionLeds();               
                SetearMotores(55,110,90,90);
                Dato_Serial=0;
                delay(1);
                SepararServos();
            }   
/*********************************************************************************************************/
/**********************Accion a realizar para cuando la respuesta sea inorrecta***************************/
    if(Dato_Serial=='I'){   //Dato recibido desde el Raspberry cuando la respuesta es incorrecto
                Serial.write(Dato_Serial);
                contador=0;
                Enable_Leds=2; //Habilitación de la bandera para el encendido de la secuencia de leds
                UnirServos();
                InicializacionLeds();
                SetearMotores(55,110,90,90);             
                SetearMotores(55,110,90,90);
                delay(500);
                SetearMotores(20,155,90,90);
                SetearMotores(20,155,90,90);
                Dato_Serial=0;
                delay(1);
                SepararServos();
            }
/*********************************************************************************************************/
/***********************Accion a realizar para cuando la respuesta sea correcta***************************/
    if(Dato_Serial=='C'){   //Dato recibido desde el Rasberry cuando la respuesta sea correcto                       
                Serial.write(Dato_Serial);
                contador=0;
                Enable_Leds=3; //Habilitación de la bandera para el encendido de la secuencia de leds
                UnirServos();
                InicializacionLeds();
                SetearMotores(110,60,90,90);
                SetearMotores(20,155,90,90);
                Dato_Serial=0;             
                delay(1);
                SepararServos();
            }
/*********************************************************************************************************/   
}
